<template>
  <v-container style="padding: 73px">
    <v-layout row>
      <v-flex xs12 md12>
        nick: <b>{{ nick }}</b>
      </v-flex>
    </v-layout>
    <v-layout row>
      <v-flex xs12 md6>
        email: <b>{{ email }}</b>
      </v-flex>
    </v-layout>
    <v-layout row>
      <v-flex xs12 md6>
        <v-text-field
          v-model="password"
          :append-icon="iconPassword"
          :type="showPassword ? 'text' : 'password'"
          :readonly="!unlockPassword"
          name="input-10-1"
          label="ustaw hasło"
          :hint="
            !unlockPassword
              ? 'najpierw odblokuj możlowość edycji'
              : 'hasło musi być wystarczająco złożone'
          "
          counter
          @click:append="show = !show"
        ></v-text-field>
        <v-progress-linear
          style="width: 200px"
          :color="metterColor"
          height="20"
          width="200"
          :value="metterValue"
          striped
        ></v-progress-linear>
        <v-text-field
          v-model="repeatPassword"
          :append-icon="iconPassword"
          :readonly="!unlockPassword"
          :type="showPassword ? 'text' : 'password'"
          name="input-10-1"
          label="powtórz hasło"
          counter
          @click:append="show = !show"
        ></v-text-field>
      </v-flex>
      <v-flex xs12 md6>
        <div class="text-center">
          <v-btn
            v-if="unlockPassword"
            @click="handleChangePassword"
            :color="unlockPassword ? 'warning' : 'accent'"
            dark
          >
          zmień hasło
            <span v-if="unlockPassword" class="seconds">
              {{ `(${passwordUnlockedRemaining})` }}
            </span>
          </v-btn>
          <v-dialog v-model="passwordDialog" width="500">
            <template v-slot:activator="{ on, attrs }">
              <v-btn :style="{ display: unlockPassword?'none':'inline-flex'}"
                @click="handleChangePassword"
                :color="unlockPassword ? 'warning' : 'accent'"
                dark
                v-bind="attrs"
                v-on="on"
              >
                  odblokuj hasło

              </v-btn>
            </template>
            <v-card>
              <v-card-title class="text-h5 info">
                {{ nick }}, podaj dotychczasowe hasło
              </v-card-title>
              <v-card-text>
                <v-text-field
                  v-model="oldPassword"
                  :append-icon="show ? 'mdi-eye' : 'mdi-eye-off'"
                  :type="show ? 'text' : 'password'"
                  label="hasło"
                  counter
                  @click:append="show = !show"
                ></v-text-field>
              </v-card-text>
              <v-divider></v-divider>
              <v-card-actions>
                <v-spacer></v-spacer>
                <v-btn @click="handleShowPassword" color="accent" text>
                  OK
                </v-btn>
                <v-snackbar v-model="snackbarPassword">
                  {{ message }}
                  <template v-slot:action="{ attrs }">
                    <v-btn
                      color="pink"
                      text
                      v-bind="attrs"
                      @click="snackbar = false"
                    >
                      Close
                    </v-btn>
                  </template>
                </v-snackbar>
              </v-card-actions>
            </v-card>
          </v-dialog>
        </div>
      </v-flex>
      <WindowComponent
        v-if="showPasswordChanged"
        @close="showPasswordChanged=false"
        header="Hasło zostało zmienione"
      />
      <v-flex sm12 md6>
        Miejscowość:
        <AutocompleteCity
          :readonly="cityReadOnly"
          :default="{ name: '', province: '' }"
          @city="setCity"
        />
      </v-flex>
      <v-flex sm12 md6>
        <div class="text-center">
          <v-btn
            @click="
              () => {
                cityReadOnly = false;
                city = '';
              }
            "
            color="accent"
            >zmień</v-btn
          >
        </div>
      </v-flex>
      <v-flex sm12 md6>
        <PhotosComponent />
      </v-flex>
    </v-layout>
    <v-card-actions class="justify-center" style="margin-top: 50px">
      <v-btn class="margin" color="primary" @click="save" raised
        >Zapisz zmiany</v-btn
      >
      <v-btn class="margin" color="warning" @click="back" raised>Zamknij</v-btn>
    </v-card-actions>
  </v-container>
</template>
<script>
import logged from '~/mixins/logged';
import password from '~/mixins/password';

export default {
  name: 'DetailsPage',

  mixins: [logged, password],

  data() {
    return {
      nick: this.$store.state.user.nick,
      email: this.$store.state.user.email,
      city: {},
      showPassword: false,
      unlockPassword: false,
      show: false,
      passwordDialog: false,
      oldPassword: '',
      oldPasswordInterval: null,
      snackbarPassword: false,
      showPasswordChanged: false,
      passwordUnlocked: -1,
      cityReadOnly: true,
      message: null,
      changeUpload: {
        changed: false,
      },
      formData: null
    };
  },

  computed: {
    iconPassword() {
      if (!this.unlockPassword) {
        return 'mdi-lock-outline';
      } else {
        if (this.showPassword) {
          return 'mdi-eye';
        } else {
          return 'mdi-eye-off';
        }
      }
    },

    passwordUnlockedRemaining() {
      if (this.passwordUnlocked === -1) {
        return;
      }
      return this.passwordUnlocked < 10
        ? '0' + this.passwordUnlocked
        : this.passwordUnlocked;
    },
  },

  async mounted() {
    await this.$axios
      .post(this.$config.serverUrl + '/city/by-id', {
        id: this.$store.state.user.city_id,
      })
      .then(({ data }) => {
        this.city = data;
        this.$bus.$emit('city-object', data);
      })
      .catch((error) => {
        console.error(error);
      });

      this.$axios.post(this.$config.serverUrl+'/user/image',{
        id: this.$store.state.user.id
      }).then(({data})=>{
        this.$refs.uploader.$refs.uploader.images[0] = 
        { default:1, hightlight:1, name: 'photo', path: data.image };
        document.querySelectorAll('img')[0].setAttribute('src',data.image);
      })
      .catch(err=>{
        console.error(err);
      });

    this.$bus.$emit('hide-menu');
  },

  unmounted() {
    this.$bus.$emit('show-menu');
  },

  methods: {
    showImage() {
      console.log(this.$refs.uploader.$refs.uploader.images[0])
    },

    handleShowPassword() {
      if (this.unlockPassword) {
      } else {
        this.passwordDialog = false;
        this.$axios
          .post(this.$config.serverUrl + '/user/authorize', {
            password: this.oldPassword,
            uuid: this.$store.state.user.uuid,
          })
          .then(({ data }) => {
            if (data.status === 'OK') {
              this.unlockPassword = true;
              this.passwordUnlocked = 60;
              this.oldPasswordInterval = setInterval(() => {
                this.passwordUnlocked -= 1;
                if (!this.passwordUnlocked) {
                  clearInterval(this.oldPasswordInterval);
                  this.unlockPassword = false;
                  this.passwordUnlocked = -1;
                }
              }, 1000);
            } else {
              this.snackbarPassword = true;
              this.message = 'Prawdopodobnie błędne hasło.';
            }
          })
          .catch((error) => {
            console.error('error');
            console.error(error);
          });
      }
    },

    handleChangePassword() {
      this.passwordDialog = false;
      if (this.unlockPassword) {
        if (!this.passwordComplexity) {
          this.message = 'Za słabe hasło';
          this.snackbarPassword = true;
          return;
        }

        if (this.password == !this.repeatPassword) {
          this.message = 'Hasła nie pasują';
          this.snackbarPassword = true;
          return;
        }

        this.$axios
          .post(this.$config.serverUrl + '/user/change-password', {
            uuid: this.$store.state.user.uuid,
            password: this.password,
          })
          .then(({ data }) => {
            this.passwordDialog = false;
            if (data.status === 'OK') {
              this.showPasswordChanged = true;
              this.passwordUnlockedRemaining = 0;
              setTimeout(() => {
                this.showPasswordChanged = false;
              }, 6000);
            }
          })
          .catch((err) => {
            console.error('Error');
            console.error(err);
          });
      }
    },

    setCity(city) {
      this.city = city;
    },
    handleChangeImage(data) {
      this.formData = data;
    },

    save() {
       
      this.$axios.put(this.$config.serverUrl+'/user/change',{
        uuid: this.$store.state.user.uuid,
        city: this.city,
        profileImage: this.$store.state.user.photos.profile,
        restOfImages: this.$store.state.user.photos.rest
      })
    },

    back() {
      this.$router.push({ path: '/profile' });
    },
  },
};
</script>
<style lang="scss" scoped>
.margin {
  margin-right: 50px !important;
}
.seconds {
  font-size: 10px;
}
</style>
